precision mediump float;
uniform sampler2D tex_y;
uniform sampler2D tex_u;
uniform sampler2D tex_v;
uniform mat3 um3_ColorConversion;
varying highp vec2 textureCoordinate;
uniform vec4 mixColor;
uniform float alpha;

void main() {
    vec3 yuv;
    vec3 rgb;
    yuv.x = (texture2D(tex_y, textureCoordinate).r - (16.0 / 255.0));
    yuv.y = (texture2D(tex_u, textureCoordinate).r - 0.5);
    yuv.z = (texture2D(tex_v, textureCoordinate).r - 0.5);
    rgb = um3_ColorConversion * yuv;
    gl_FragColor = vec4(rgb, alpha);
}