precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float mixturePercent;
uniform lowp int isReverse;
void main() {
    vec4 base = texture2D(inputImageTexture, textureCoordinate);
    vec4 overlay = texture2D(inputImageTexture2, textureCoordinate2);
    if (isReverse == 0){
        vec4 result = vec4(mix(overlay.rgb, base.rgb, overlay.a), base.a*overlay.a);
        vec4 c2 = vec4(0.0);
        gl_FragColor =vec4(mix(c2.rgba, result.rgba, mixturePercent));
    } else {
        vec4 result = vec4(mix(overlay.rgb, base.rgb, 1.0 - overlay.a), 1.0 - base.a*overlay.a);
        vec4 c2 = vec4(0.0);
        gl_FragColor =vec4(mix(c2.rgba, result.rgba, mixturePercent));
    }

}
