precision lowp float;

varying lowp vec2 textureCoordinate;
varying lowp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float mixturePercent;
uniform lowp int saveState;

uniform float zoom_quickness; // = 0.8

vec4 getFromColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture, p);
    }
}

vec4 getToColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture2, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture2, p);
    }
}

vec2 zoom(vec2 uv, float amount) {
    return 0.5 + ((uv - 0.5) * (1.0-amount));
}

vec4 transition (vec2 uv) {
    float nQuick = clamp(zoom_quickness,0.2,1.0);
    return mix(
        getFromColor(zoom(uv, smoothstep(0.0, nQuick, mixturePercent))),
        getToColor(uv),
        smoothstep(nQuick-0.2, 1.0, mixturePercent)
    );
}

void main(){
    gl_FragColor = transition(textureCoordinate2);
}