precision lowp float;
varying lowp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec3 keyColor;
uniform float threshold;
uniform float smoothing;

void main()
{
    highp vec4 color = texture2D(inputImageTexture, textureCoordinate);
    highp float diff = length(color.rgb - keyColor);
//    if (diff < threshold)
//    gl_FragColor = vec4(color.rgb, 0.0); // 透明
//    else
//    gl_FragColor = color; // 保留原始颜色

    float alpha = smoothstep(threshold - smoothing, threshold + smoothing, diff);

    // 将透明度应用到输出颜色
    gl_FragColor = vec4(color.rgb, alpha);
}