precision lowp float;

varying lowp vec2 textureCoordinate;
varying lowp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float mixturePercent;
uniform lowp int saveState;

uniform vec4 bgcolor; // = vec4(0.0, 0.0, 0.0, 1.0)
uniform float ratio; 

vec4 getFromColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture, p);
    }
}

vec4 getToColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture2, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture2, p);
    }
}

vec4 transition(vec2 p) {
    vec2 ratio2 = vec2(1.0, 1.0 / ratio);
    float s = pow(2.0 * abs(mixturePercent - 0.5), 3.0);
    float dist = length((vec2(p) - 0.5) * ratio2);
    return mix(
        mixturePercent < 0.5 ? getFromColor(p) : getToColor(p), // branching is ok here as we statically depend on mixturePercent uniform (branching won't change over pixels)
        bgcolor,
        step(s, dist)
    );
}

void main(){
    gl_FragColor = transition(textureCoordinate2);
}