precision lowp float;

varying lowp vec2 textureCoordinate;
varying lowp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float mixturePercent;
uniform lowp int saveState;

uniform float amplitude; // = 30
uniform float speed; // = 30

vec4 getFromColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture, p);
    }
}

vec4 getToColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture2, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture2, p);
    }
}

vec4 transition(vec2 p) {
    vec2 dir = p - vec2(.5);
    float dist = length(dir);

    if (dist > mixturePercent) {
        return mix(getFromColor( p), getToColor( p), mixturePercent);
    } else {
        vec2 offset = dir * sin(dist * amplitude - mixturePercent * speed);
        return mix(getFromColor( p + offset), getToColor( p), mixturePercent);
    }
}

void main(){
    gl_FragColor = transition(textureCoordinate2);
}