precision lowp float;

varying lowp vec2 textureCoordinate;
varying lowp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float mixturePercent;
uniform lowp int saveState;

uniform float count;
uniform float smoothness;

vec4 getFromColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture, p);
    }
}

vec4 getToColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture2, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture2, p);
    }
}

vec4 transition (vec2 p) {
    float pr = smoothstep(-smoothness, 0.0, p.x - mixturePercent * (1.0 + smoothness));
    float s = step(pr, fract(count * p.x));
    return mix(getFromColor(p), getToColor(p), s);
}

void main(){
    gl_FragColor = transition(textureCoordinate2);
}