precision lowp float;

varying lowp vec2 textureCoordinate;
varying lowp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float mixturePercent;
uniform lowp int saveState;

vec4 getFromColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture, p);
    }
}

vec4 getToColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture2, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture2, p);
    }
}

vec2 offset(float mixturePercent, float x, float theta) {
  float phase = mixturePercent*mixturePercent + mixturePercent + theta;
  float shifty = 0.03*mixturePercent*cos(10.0*(mixturePercent+x));
  return vec2(0, shifty);
}

vec4 transition(vec2 p) {
  return mix(getFromColor(p + offset(mixturePercent, p.x, 0.0)), getToColor(p + offset(1.0-mixturePercent, p.x, 3.14)), mixturePercent);
}

void main(){
    gl_FragColor = transition(textureCoordinate2);
}