precision lowp float;

varying lowp vec2 textureCoordinate;
varying lowp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float mixturePercent;
uniform lowp int saveState;


vec4 getFromColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture, p);
    }
}

vec4 getToColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture2, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture2, p);
    }
}

vec4 transition(vec2 p) {
  vec2 block = floor(p.xy / vec2(16));
  vec2 uv_noise = block / vec2(64);
  uv_noise += floor(vec2(mixturePercent) * vec2(1200.0, 3500.0)) / vec2(64);
  vec2 dist = mixturePercent > 0.0 ? (fract(uv_noise) - 0.5) * 0.3 *(1.0 -mixturePercent) : vec2(0.0);
  vec2 red = p + dist * 0.2;
  vec2 green = p + dist * .3;
  vec2 blue = p + dist * .5;

  return vec4(mix(getFromColor(red), getToColor(red), mixturePercent).r,mix(getFromColor(green), getToColor(green), mixturePercent).g,mix(getFromColor(blue), getToColor(blue), mixturePercent).b,1.0);
}

void main(){
    gl_FragColor = transition(textureCoordinate2);
}