precision lowp float;

varying lowp vec2 textureCoordinate;
varying lowp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float mixturePercent;
uniform lowp int saveState;

uniform vec3 color /* = vec3(0.9, 0.4, 0.2) */;


vec4 getFromColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture, p);
    }
}

vec4 getToColor(vec2 p){
    if(saveState==1){
        return texture2D(inputImageTexture2, vec2(p.x,1.0-p.y));
    } else {
        return texture2D(inputImageTexture2, p);
    }
}

vec4 transition (vec2 uv) {
  return mix(
    getFromColor(uv) + vec4(mixturePercent*color, 1.0),
    getToColor(uv) + vec4((1.0-mixturePercent)*color, 1.0),
    mixturePercent
  );
}

void main(){
    gl_FragColor = transition(textureCoordinate2);
}